<template>
  <v-container>
    <div id="scene" ref="scene" class="scene" />
  </v-container>
</template>

<script>
import * as THREE from 'three'
import { GLTFLoader } from 'three/examples/jsm/loaders/GLTFLoader.js'

let container
let camera
let renderer
let scene
let face

export default {
  data: () => ({}),

  mounted() {
    this.init()
    window.addEventListener('resize', this.onWindowResize)
  },

  methods: {
    init() {
      container = this.$refs.scene
      scene = new THREE.Scene()

      const fov = 55
      const aspect = '500' / '500'
      const near = 0.1
      const far = 1000

      camera = new THREE.PerspectiveCamera(fov, aspect, near, far)
      camera.position.set(0, 5, 30)

      const ambient = new THREE.AmbientLight(0x404040, 4)
      scene.add(ambient)

      const light = new THREE.DirectionalLight(0x404040, 3)
      light.position.set(59, 59, 100)
      scene.add(light)

      renderer = new THREE.WebGLRenderer({ antialias: true, alpha: true })
      renderer.setSize(container.clientWidth, container.clientHeight)
      renderer.setPixelRatio(window.devicePixelRatio)

      container.appendChild(renderer.domElement)

      const loader = new GLTFLoader()
      loader.load('/assets/models/face.gltf', (gltf) => {
        scene.add(gltf.scene)
        face = gltf.scene.children[0]
        this.animate()
      })
    },

    animate() {
      requestAnimationFrame(this.animate)
      face.rotation.z += 0.005
      renderer.render(scene, camera)
    },

    onWindowResize() {
      camera.aspect = container.clientWidth / container.clientHeight
      camera.updateProjectionMatrix()

      renderer.setSize(container.clientWidth, container.clientHeight)
    },
  },
}
</script>

<style lang="scss" scoped>
.scene {
  background-color: rgba(42, 25, 46, 0.731);
  width: 20rem;
  height: 20rem;
}
</style>